\documentclass{article}

\usepackage{mpi0102t1}

\title{\esimo1 Trabalho Prtico}

\author{
	\mpi{Mtodos de Programao I}
	\\ 
	\lesi{LESI}/\lmcc{LMCC}
	\\ Universidade do Minho
}


\date{Ano Lectivo de 2001/2002}

\begin{document}
\maketitle

\section{Prembulo}

Este trabalho deve ser realizado por grupos com um mximo de trs
alunos. O trabalho deve ser entregue at ao dia \pisca{31 de Outubro} na
Recepo do \dium\ (ext. 4430) e nele deve constar a listagem do cdigo
desenvolvido assim como um pequeno relatrio.

\section{Introduo}
Nos sistemas da famlia \Unix\ (\eg\ \Linux) existe a noo de
shell de interpretao de comandos ao nvel do sistema operativo.
H vrias shells desse tipo, sendo a \bash{bash} uma das mais populares.

Neste trabalho pretende-se emular em \Haskell\ a abertura de uma
shell de programao desse tipo.
Uma tal shell, uma vez invocada, dever abrir um interpretador de comandos
capaz de dar a iluso de se estar a trabalhar em \Unix/\Linux.
 claro que essa iluso ser tanto maior quanto mais extensa e detalhada for
a emulao.

Tal como  habitual nos trabalhos desta disciplina,
fornece-se de seguida um kit para arranque do projecto.
O enunciado concluir-se- com sugestes para valorizao do trabalho a realizar.

\section{Material fornecido como kit para o projecto}
Entre na pgina da disciplina e descarregue,
descomprimindo-o (\eg\ via \texttt{unzip}), o ficheiro
\mpiMP{\texttt{mpi0102mp.zip}} que contm o respectivo material pedaggico.
%
Para alm de outros ficheiros relevantes para a disciplina, dever obter:
\begin{enumerate}
\item	\texttt{mpi0102t1.lhs} - trata-se do ficheiro que est a ler neste
momento, escrito em \litp{literate} \Haskell. Isto significa que:
	\begin{itemize}
	\item	se o carregar no \Hugs, este interpretador carregar o cdigo
		\Haskell\ nele contido e interpret-lo-.
		Sugesto: invoque o \Hugs\ e experimente
		\texttt{:l mpi0102t1.lhs}.
	\item	se o processar via \LaTeX\ (ou PDF\LaTeX) obter este mesmo
		documento em \pdf{PDF}.
		Sugesto: experimente \texttt{pdflatex mpi0102t1.lhs}.

		(Se no est habituado a \LaTeX: em \Linux, faz parte da
		 distribuio standard,  s experimentar;
		 em Windows, que tal instalar o \miktex{MiK\TeX}?
		 Mas note que esse esforo, embora aconselhvel,
		 no  essencial  realizao deste trabalho.)
	\end{itemize}
\item	\texttt{mpi0102t1.sty} - trata-se de um ficheiro importado por
	\texttt{mpi0102t1.lhs}, contendo funes de processamento de texto
	expressas em sintaxe \LaTeX\ (como poder ver,  normal programar
	\emph{funcionalmente} em \LaTeX).
\item	\texttt{mpi0102t1.pdf} - trata-se do resultado do processamento de
	\texttt{mpi0102t1.lhs} para sua convenincia, caso no tenha \LaTeX\
	acessvel.
\end{enumerate}

\section{Utilizao do kit do projecto}
Aps carregar \texttt{mpi0102t1.lhs} no seu interpretador de \Haskell, digite
\texttt{shell} e entrar no emulador:
\begin{verbatim}
Main> :l mpi0102t1.lhs 
Reading file "mpi0102t1.lhs":
                   
Hugs session for:
/home/fln/share/hugs/lib/Prelude.hs
mpi0102t1.lhs
Main> shell
$ 
\end{verbatim}
Note o novo prompt \texttt\$. Para sair,
escreva \texttt{exit}:
\begin{verbatim}
$ exit
 :: IO ()
Main> 
\end{verbatim}
Observe assim o recurso  mnada \texttt{IO}.
Volte a entrar e tente o bem conhecido comando \texttt{cat}:
\begin{verbatim}
Main> shell
$ cat
Comando desconhecido
$ 
\end{verbatim}
Pois , esse comando ainda no est previsto em \texttt{mpi0102t1.lhs}.
E se tentar, por exemplo, \texttt{wc}, obter
\begin{verbatim}
Main> shell
$ wc
Comando wc nao implementado
$
\end{verbatim}
Aqui verifica-se que o comando est j previsto, mas ainda por implementar.
Em boa verdade, \texttt{mpi0102t1.lhs}  uma \emph{concha} de interpretao de
comandos praticamente vazia.
Apenas o comando \texttt{head} est (parcialmente!) implementado:
\begin{verbatim}
$ head -1 mpi0102t1.lhs
\documentclass{article}
$ 
\end{verbatim}

O seu trabalho dever consistir, precisamente, em encher \texttt{shell}
de contedo apropriado.
Vejamos ento o que j est feito.

\section{Anlise do kit do projecto}
Segue-se o cdigo \Haskell\ que se prope como ponto de partida para este
trabalho.

\subsection{Tipos}
Observe que \texttt{Comando} apenas prev alguns dos comandos mais conhecidos
da \bash{bash}:

\begin{code}
data Comando = Wc Opcoes [FilePath]
             | Head Opcoes [FilePath]
             | Tail Opcoes [FilePath]
             | Cut  Opcoes [FilePath]
             | Desconhecido String

type Opcoes = String
\end{code}

\noindent
Poder (e dever) enriquecer esta \emph{sintaxe abstracta} com mais
construtores,
por forma a enriquecer o vocabulrio da sua \emph{shell}.
\subsection{Leitura de comandos}
Analise com ateno as duas funes que se seguem:
\begin{code}
readComando :: String -> Comando
readComando l = let [(c,cs)] = lex l
                in case c of 
                   "wc"   -> mkCom Wc cs
                   "head" -> mkCom Head cs
                   "tail" -> mkCom Tail cs
                   "cut"  -> mkCom Cut cs
                   _      -> Desconhecido l

mkCom :: (Opcoes -> [FilePath] -> Comando) -> String -> Comando
mkCom c s = case (words s) of 
            []           -> c "" []
            (('-':op):r) -> c op r
            (h:t)        -> c "" (h:t)
\end{code}

\subsection{Execuo de Comandos}
Esta  realizada pela funo mondica \texttt{executa}:
\begin{code}
executa :: Comando -> IO ()
executa (Wc   op fichs) = putStrLn "Comando wc nao implementado"
executa (Head op fichs) = sequence_ (map (rHead (read op)) fichs)
executa (Tail op fichs) = putStrLn "Comando tail nao implementado"
executa (Cut  op fichs) = putStrLn "Comando cut nao implementado"
executa (Desconhecido _)= putStrLn "Comando desconhecido"
\end{code}

\noindent
Note que apenas o comando \texttt{head} est (parcialmente) implementado:

\begin{code}
rHead :: Int -> FilePath -> IO ()
rHead n f = do { s <- readFile f ; 
                sequence_ (map putStrLn (take n (lines s)))
              }
\end{code}

De facto, o comando no faz qualquer anlise de erros e o \textsl{output},
quando invocado com mltiplos \textsl{file paths},
no corresponde exactamente ao que um sistema \Unix\ produz.

\subsection{Shell interactiva}
Finalmente, a funo que implementa a abertura da sua \emph{concha} de
programao:
\begin{code}
shell = do { putStr prompt;
             c <- getLine ;
             if c == "exit"
                then stop 
                else do { executa (readComando c) ;
                          shell 
                        }
           }

stop :: IO ()
stop = return ()

prompt = "$ "
\end{code}

\section{Sugestes para Valorizao}
\begin{itemize}
\item	Redefina o tipo \texttt{Comando} de forma a poder expressar
	\textsl{pipe}s.
\item	Ao invs de escrever \texttt{Comando desconhecido},
	tente invocar um comando equivalente do prprio sistema operativo
	subjacente.
\item	Emule em \texttt{mpi0102t1.lhs} um nmero expressivo dos comandos
	da \bash{bash}.
\end{itemize}

\end{document}

