\documentclass{article}

\usepackage{mpi0102t2}

\title{\esimo2 Trabalho Prtico}

\author{
	\mpi{Mtodos de Programao I}
	\\
	\lesi{LESI}/\lmcc{LMCC}
	\\
	Universidade do Minho
}


\date{Ano Lectivo de 2001/2002}

\begin{document}

\maketitle

%\tableofcontents

\section{Introduo}
\label{sec:Introd}
 vulgar em documentos cientficos
(monografias, livros, artigos, \etc) existir um apndice de
bibliografia contendo a descrio de todos os documentos que foram
citados ao longo do texto principal.

Um ndice remissivo de autores  mais um apndice ao texto principal indicando,
por ordem alfabtica de nomes de autores referidos e para cada nome de autor,
a lista ordenada das pginas em que vem citadas
publicaes suas,
por exemplo:
\begin{indice}
\autor{Arbib}{M. A.}{10, 11}
\autor{Bird}{R.}{28}
\autor{Horowitz}{E.}{2, 3, 15, 16, 19}
\autor{Hudak}{P.}{11, 12, 29}
\autor{Jones}{C. B.}{3, 7, 28}
\autor{Manes}{E. G.}{10, 11}
\autor{Sahni}{S.}{2, 3, 15, 16, 19}
\autor{Spivey}{J.M.}{3, 7}
\autor{Wadler}{P.}{2, 3}
\end{indice}

No ambiente \LaTeX\ \ncite{La86} para preparao de texto a gerao de
bibliografias pode ser feita automaticamente a partir de uma base de dados
bibliogrfica que associa a cada documento uma
\emph{chave de citao} que o identifica univocamente.
O processamento de tal base de dados  realizado por um utilitrio designado
\Bibtex.

J a gerao de ndices remissivos de autores no est
prevista na instalao \LaTeX\ de base.
O objectivo deste trabalho  desenvolver um utilitrio para esse efeito,
a implementar e compilar em \Haskell \ncite{J*99,Hu00,VB00}.

Para perceber este trabalho ser conveniente ter alguma convivncia com
\LaTeX.
Em \Linux, faz parte da distribuio standard e  s experimentar.
Em Windows, sugere-se a instalao de \miktex{MiK\TeX}
(\texttt{www.miktex.org}).

\section{Material fornecido como kit para o projecto}
Entre na pgina da disciplina e descarregue,
descomprimindo-o (\eg\ via \texttt{unzip}), o ficheiro
\mpiMP{\texttt{mpi0102mp.zip}} que contm o respectivo material pedaggico.
%
Para alm de outros ficheiros relevantes para a disciplina, dever obter:
\begin{enumerate}
\item	\texttt{mpi0102t2.lhs} - trata-se do ficheiro que est a ler neste
momento, escrito em \litp{literate} \Haskell. Isto significa que:
	\begin{itemize}
	\item	se o carregar no \Hugs, este interpretador ler o cdigo
		\Haskell\ nele contido e interpret-lo-.
		Sugesto: invoque o \Hugs\ e experimente
		\texttt{:l mpi0102t2.lhs}.
	\item	se o processar via \LaTeX\ (ou PDF\LaTeX) obter este mesmo
		documento em \pdf{PDF}.
	\end{itemize}
\item	\texttt{mpi0102t2.sty} - trata-se de um ficheiro importado por
	\texttt{mpi0102t1.lhs} e contendo funes de processamento de texto
	expressas em sintaxe \LaTeX\ (como poder ver inspeccionando
	este ficheiro,  normal programar \emph{funcionalmente} em \LaTeX).
\item	\texttt{mpi0102t2.pdf} - trata-se do resultado do processamento de
	\texttt{mpi0102t2.lhs}, o ficheiro que est a ler.
\item	\texttt{mpi0102t2.bib} - trata-se de um ficheiro exemplo de
		bibliografia.
\item	\texttt{MonadicPComb.hs} - mdulo auxiliar para reconhecimento do
	formato bibliogrfico.
\end{enumerate}

\section{Anlise do kit do projecto}
Vamos usar o texto deste enunciado para ilustrar o funcionamento do
processamento bibliogrfico em \Latex:
\begin{enumerate}
\item	Comece por invocar
\begin{verbatim}
   pdflatex mpi0102t2.lhs
\end{verbatim}
	Verifique que  directoria de trabalho se acrescentaram vrios
	ficheiros \texttt{mpi0102t2.*},
	entre os quais aquele que est a ler neste momento
	--- \texttt{mpi0102t2.pdf} ---
	que poder imprimir.
	Mas repare que h pontos de interrogao \textbf{[?]} nesse
	ficheiro, exactamente nos locais onde, em \texttt{mpi0102t2.lhs},
	se invoca a funo \texttt{ncite}.
\item	Os argumentos da funo \texttt{ncite} so chaves de referncias
	bibliogrficas que vai ser preciso cruzar com a base de dados de
	bibliografia --- o ficheiro \texttt{mpi0102t2.bib} ---
	que inclui registos como, por exemplo:

\begin{verbatim}
@book{Hu00,
   author = {P. Hudak},
   title = {\htmladdnormallink{
                The Haskell School of Expression - Learning Functional
                Programming Through Multimedia
            }{
                http://www.cup.cam.ac.uk}
           },
   publisher = {Cambridge University Press},
   edition = {1st},
   year = {2000},
   note = {ISBN 0-521-64408-9}
}
\end{verbatim}
	
\item	Para isso invoque \texttt{bibtex mpi0102t2}.
	Este utilitrio dever gerar o ficheiro \texttt{mpi0102t2.bbl}
	que ir ser anexado a \texttt{mpi0102t2.pdf}.
	De facto, ser voltar a correr \texttt{pdflatex mpi0102t2.lhs} poder
	reparar que uma nova seco de \textbf{Bibliografia} foi
	(automaticamente) anexada.
	Por exemplo, a entrada referente a \texttt{Hu00} acima converte-se em

\begin{description}
\item{\cite{Hu00}}
P.~Hudak.
\newblock {\em \htmladdnormallink{ The Haskell School of Expression - Learning
  Functional Programming Through Multimedia }{http://www.cup.cam.ac.uk}}.
\newblock Cambridge University Press, 1st edition, 2000.
\newblock ISBN 0-521-64408-9.
\end{description}

\item	Repare ainda que \texttt{pdflatex mpi0102t2.lhs} gera um outro
	ficheiro auxiliar, \texttt{mpi0102t2.bkp}, cuja estrutura 
	muito simples, relacionando chaves de citao
	(argumentos de \texttt{ncite}) com a pgina onde essa citao 
	feita:
\begin{verbatim}
1,La86
1,J*99,Hu00,VB00
5,J*99,VB00
\end{verbatim}

\item	Os ficheiros \texttt{mpi0102t2.bkp} e \texttt{mpi0102t2.bib}
	contm a informao necessria para gerar o ndice de autores
	pretendido.  esse o objectivo do seu trabalho, a realizar em
	\Haskell.

\end{enumerate}

Como  habitual nos trabalhos desta disciplina,
fornece-se um kit para arranque do projecto.
O enunciado concluir-se- com sugestes para valorizao do trabalho a realizar.

\section{Utilizao do kit do projecto}
Aps carregar \texttt{mpi0102t1.lhs} no seu interpretador de \Haskell,
verifique que, aps a importao de dois mdulos que conhece,
%
\begin{code}
import Mpi
import List
\end{code}

\noindent
e de um outro mais  frente necessrio  realizao deste trabalho,
\begin{code}
import MonadicPComb
\end{code}

\noindent
se definem os tipos
\begin{code}
type Bkp = [(Page,[Key])] -- bib.key/page data imported from *.bkp file
type Bib = [(Key,[Author])]     -- bibtex data imported from *.bib file
\end{code}
correspondentes ao registo da informao desses ficheiros em \Haskell,
onde
\begin{code}
type Key = String
type Page   = Int
data Author = Author { initials :: String, surname  :: String } deriving Show
\end{code}
so tipos auxiliares.

Para efeitos de validao dispe, no anexo \ref{anexo-dados},
duas constantes \texttt{bkp :: Bkp} e \texttt{bib :: Bib},
usando-se no segundo caso a abreviatura
\begin{code}
x |-> y = (x,y)
\end{code}
Pode apreciar o uso dos combinadores \uk{pointfree} estudados nas aulas
em funes como, por exemplo,
\begin{code}
getb :: Bib -> [(String,[(String,String)])]
getb = map (id >< map (split initials surname))
\end{code}
que extrai informao relevante a partir de objectos do tipo \texttt{Bib}.
 
\subsection{Estratgia}
O nosso objectivo  sintetizar, a partir de \texttt{Bkp} e \texttt{Bib},
o ndice de autores e pginas onde so referidos, tudo devidamente ordenado: 
\begin{code}
type Ind = [(Author,[Page])]
\end{code}
Ser a partir do objecto do tipo \texttt{Ind} obtido que dever ser produzido
o ficheiro \texttt{mpi0102t2.ind}
--- por exemplo no formato sugerido na pgina \pageref{sec:Introd} ---
que o \Latex\ anexar automaticamente ao PDF gerado atravs da \uk{package}
\texttt{mmakeidx} (importada em \texttt{mpi0102t2.sty}).

Sugere-se a seguinte arquitectura para a funo a realizar,
\[
\xymatrix@C=0.5ex @R=3ex{%
        bkp
                \ar[d]
&&
	bib
                \ar[d]
\\
        \funbox{discollect}
                \ar[ddr]
&&
        \funbox{getb}
                \ar[d]
\\
&&
        \funbox{discollect}
                \ar[dl]
\\
&
        \funbox{rcomp}
                \ar[d]
\\
&
        \funbox{rinv}
                \ar[d]
\\
&
        \funbox{collect}
                \ar[d]
\\
&
        \mapbox{swap $\times$ sort}
                \ar[d]
\\
&
        \funbox{sort}
                \ar[d]
\\
&
        \mapbox{uAuthor $\times$ id }
                \ar[d]
\\
&
	ind
}
\]

\noindent
-- em que
\begin{code}
uAuthor = (uncurry Author) . swap
\end{code}
e \fbox{\fbox{\texttt f}} representa \texttt{map f } ---
que  fielmente captada pela seguinte expresso funcional \uk{pointfree}:

\begin{code}
mkInd :: Bkp -> Bib -> Ind
mkInd = curry (
        map (uAuthor >< id) .
        sort .
        map (swap >< sort) .
        collect .
        rinv .
        rcomp .
        (discollect >< discollect . getb)
        )
\end{code}

Para as constantes disponibilizadas no anexo \ref{anexo-dados},
esta funo dever dar o resultado seguinte:

\begin{verbatim}
Main> mkInd bkp bib
[(Author{initials="M.A.",surname="Arbib"},[10]),
(Author{initials="L.S.",surname="Barbosa"},[28]),
(Author{initials="J.B.",surname="Barros"},[2,28,29]),
(Author{initials="E.",surname="Fielding"},[24,25]),
(Author{initials="P.H.B.",surname="Gardiner"},[8]),
(Author{initials="J.A.",surname="Goguen"},[28]),
(Author{initials="E.",surname="Horowitz"},[2,16]),
(Author{initials="C.B.",surname="Jones"},[3,7,28]),
(Author{initials="I.S.",surname="Jourdan"},[11,17,29]),
(Author{initials="J.",surname="Le Goff"},[10]),
(Author{initials="E.G.",surname="Manes"},[10]),
(Author{initials="C.",surname="Morgan"},[8]),
(Author{initials="F.S.",surname="Moura"},[28]),
(Author{initials="J.N.",surname="Oliveira"},[2,9,10,17,28,29]),
(Author{initials="C.J.",surname="Rodrigues"},[29]),
(Author{initials="S.",surname="Sahni"},[2,16]),
(Author{initials="J.M.",surname="Spivey"},[3,7]),
(Author{initials="J.M.",surname="Valenca"},[2,28,29]),
(Author{initials="N.",surname="Wirth"},[2,3]),
(Author{initials="J.C.P.",surname="Woodcock"},[29])] :: [(Author,[Int])]
Main>
\end{verbatim}

\subsection{Reconhecimento do formato \Bibtex}
No anexo \ref{parseBib} dispe de funes para reconhecimento de
(parte do) formato \Bibtex.
Faa
\begin{verbatim}
       parse parseItem ex1
\end{verbatim}
ou
\begin{verbatim}
       parse parseBib exemplo
\end{verbatim}
para testar,
onde \texttt{ex1} e \texttt{exemplo} so strings
(ver anexo \ref{anexo-dados}).

\section{O que h a fazer}
\begin{enumerate}
\item	Realizar a funo \texttt{mkInd} da forma sugerida
	(ou outra, desde que justificadamente melhor).
\item	Testar o seu comportamento (pelo menos) nas situaes seguintes:
	\begin{enumerate}
	\item	Para as constantes dadas no anexo \ref{anexo-dados}.
	\item	Para a situao em que \texttt{bkp} cita chaves que
		no se encontram em \texttt{bib}.
	\item	Para a situao em que \texttt{bib} contm mais entradas
		bibliogrficas que as que ocorrem em \texttt{bkp}.
	\item	Para a situao em que \texttt{bib} repete entradas de
		bibliografia.
	\end{enumerate}

\item	Colagem ao \Latex:
	realizar funes mondicas de leitura e escrita da informao nos
	ficheiros relevantes.
\item	Compilar a verso final em GHC, por forma ficar disponvel um
	filtro independente do \Hugs, capaz de ser utilizado por qualquer
	adepto de \Latex, em qualquer sistema operativo onde \Latex\ esteja
	instalado.
\item	Testar tudo com o presente documento (\texttt{mpi0102t2.lhs})
	\footnote{Esta nota de rodap repete algumas citaes bibliogrficas
		para efeitos de teste: \ncite{J*99,VB00}.
	}.
\end{enumerate}

\subsection{Sugestes para Valorizao}
\begin{itemize}
\item	Realizar funcionalidade para construo de histogramas de
	citao (por anos e por autores).
\item	Exportar ndice de autores em formato \Html\ e CSV (para importao
	em folhas de clculo, \etc)
\item	Estender o reconhecimento a todo o formato \Bibtex.
\end{itemize}

\appendix

\section{Funes por implementar}
As seguintes funes so relevantes para a realizao do seu trabalho.
Delas apenas se d a respectiva assintaura.
Para que o \Hugs\ as interprete sem erros todas foram reduzidas 
funo constante lista vazia.
Esforce-se por defini-las em notao pointfree.

\begin{code}
dunion :: Eq a => [[a]] -> [a]
dunion = const []

discollect :: (Eq a, Eq b) => [(b,[a])] -> [(b,a)]
discollect = const []

rinv :: [(a,b)] -> [(b,a)]
rinv = const []

sel1 :: Eq a => a -> [(a,b)] -> [(a,b)]
sel1 a = const []

sel2 :: Eq a => a -> [(b,a)] -> [(b,a)]
sel2 b = const []

rcomp :: Eq a => ([(b,a)],[(a,c)]) -> [(b,c)]
rcomp = const []

collect :: (Eq a, Eq b) => [(a,b)] -> [(a,[b])]
collect = const []

dom :: [(a,b)] -> [a]
dom = const []

rng :: Eq a => [(b,a)] -> [a]
rng = const []

\end{code}

\section{Sugestes para parser de formato \Bibtex} \label{parseBib}

\begin{code}

data BibItem = Item String String [(String,String)] deriving Show

parseBib :: Parse [BibItem]
parseBib = parseSeq parseItem

parseItem :: Parse BibItem
parseItem = do { parseConst "@" ;
                 tipo <- parseString ;
                 (autor, pares) <- parseChaveta parseAtribs ;
                 return (Item tipo autor pares)
               }
              
parseAtribs = do { autor <- parseStringTo ',' ;
                   parseConst "," ;
                   pares <- parseSeqSep ","  parseAtrib ;
                   return (autor,pares)
                 }

parseAtrib :: Parse (String,String)
parseAtrib = do { x <- parseString ;
                  parseConst "=" ;
                  y <- parseString ;
                  return (x,y)
                }
\end{code}

\section{Constantes para validao} \label{anexo-dados}

\begin{code}

bkp :: Bkp
bkp = [
        (2,["Wi76","HS??"]),
        (2,["VB00","Ol92"]),
        (3,["Wi76"]),
        (3,["Jo86"]),
        (3,["Sp89"]),
        (3,["Jo80"]),
        (7,["Jo86"]),
        (7,["Sp89"]),
        (8,["MG90"]),
        (9,["NG90"]),
        (9,["Ol92"]),
        (10,["Le84"]),
        (10,["Ol92"]),
        (10,["MA86"]),
        (11,["Jo92"]),
        (16,["HS??"]),
        (17,["Jo92","Ol92"]),
        (24,["Fi80"]),
        (25,["Fi80"]),
        (28,["Go86"]),
        (28,["OM95"]),
        (28,["Ba95"]),
        (28,["Ba95"]),
        (28,["Jo80"]),
        (28,["Ol92","VB00"]),
        (29,["Wo92"]),
        (29,["VB00"]),
        (29,["Ol90","Ol92","Jo92","Ro93"])
      ]
\end{code}

\begin{code}
bib :: Bib
bib = [
           "Ba95"  |-> [ Author "L.S." "Barbosa" ],
           "Fi80"  |-> [ Author "E." "Fielding" ],
           "Le84"  |-> [ Author "J." "Le Goff" ],
           "Go86"  |-> [ Author "J.A." "Goguen" ],
           "HS??"  |-> [ Author "E." "Horowitz" , Author "S."  "Sahni" ],
           "Jo80"  |-> [ Author "C.B." "Jones" ],
           "Jo86"  |-> [ Author "C.B." "Jones" ],
           "Jo92"  |-> [ Author "I.S." "Jourdan" ],
           "MA86"  |-> [ Author "E.G." "Manes" , Author "M.A."  "Arbib" ],
           "MG90"  |-> [ Author "C." "Morgan" , Author "P.H.B."  "Gardiner" ],
           "OC93"  |-> [ Author "J.N." "Oliveira" , Author "A.M."  "Cruz" ],
           "OM95"  |-> [ Author "J.N." "Oliveira" , Author "F.S."  "Moura" ],
           "Ol90"  |-> [ Author "J.N." "Oliveira" ],
           "Ol92"  |-> [ Author "J.N." "Oliveira" ],
           "Ro93"  |-> [ Author "C.J." "Rodrigues" ],
           "Sp89"  |-> [ Author "J.M." "Spivey" ],
           "VB00"  |-> [ Author "J.M." "Valenca" , Author "J.B." "Barros" ],
           "Wi76"  |-> [ Author "N." "Wirth" ],
           "Wo92"  |-> [ Author "J.C.P." "Woodcock" ]
         ]

\end{code}

\begin{code}
exemplo:: String
exemplo = ex1 ++ ex2

ex1:: String
ex1 = concat [
   "@book{oprw1,",
   "  title         = \"Resolution of Equations in Algebraic Structures.",
   "                   Volume 2: Rewriting Techniques\",",
   "  editor        = \"Maurice Nivat and Hassan Ait-Kaci\",",
   "  year          = 1989,",
   "  publisher     = \"Academic Press, New York\",",
   "  key           = \"Nivat and Ait-Kaci\" }"]

ex2:: String
ex2 = concat [
   "@inproceedings{GB:rta89,",
   "     author = \"Garrett Birkhoff\",",
   "     month = apr,",
   "     year = 1989,",
   "     title = \"Rewriting Ideas from Universal Algebra\",",
   "     booktitle = rta89,",
   "     editor = nd,",
   "     address = ch,",
   "     pages = \"1\",",
   "     note = lncs355",
   "}"]
\end{code}

\bibliography{mpi0102t2}

\printIndex

\end{document}

